﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace InteractiveJewels
{
    /// <summary>
    /// Interaction logic for Jewel.xaml
    /// </summary>
    public partial class Jewel : UserControl
    {
        public Jewel()
        {
            InitializeComponent();
        }

        private int jewelColor = 1;
        private Color[] colors = new Color[] { Colors.Black, Colors.Red, Colors.Green, Colors.Blue, Colors.White, Colors.Yellow, Colors.Purple };

        private bool isSelected = false;

        public int X { get; set; }
        public int Y { get; set; }

        public bool IsSelected
        {
            get { return isSelected; }
            set { isSelected = value;
                if (value)
                {
                    JewelBorder.BorderThickness = new Thickness(40);
                } else
                {
                    JewelBorder.BorderThickness = new Thickness(0);
                }
            }
        }

        public bool IsRemoved { get; set; }

        public int WillFall { get; set; }


        public int JewelColor
        {
            get
            {
                return jewelColor;
            }

            set
            {
                jewelColor = value;
                JewelBorder.Background = new SolidColorBrush(colors[value]);
            }
        }

        private bool isReachable = true;
        public bool IsReachable
        {
            get
            {
                return isReachable;
            }

            set
            {
                isReachable = value;
                if(!value)
                {
                    JewelBorder.Opacity = 0.3;
                } else
                {
                    JewelBorder.ClearValue(OpacityProperty);
                }
            }
        }
    }
}
